package edu.swe622.fers.model;

public class LocationGeo extends Location {
	private static final long serialVersionUID = 283357528124484165L;

	public LocationGeo(double x, double y) {
		super();
		this.cordX = x;
		this.cordY = y;
	}	
		
	@Override
	public double howFarIs(Location location2) throws LocationMismatch {
		if(!(location2 instanceof LocationGeo))
			throw new LocationMismatch();
		
		LocationGeo loc2 = (LocationGeo) location2;
		LatLong llsource = new LatLong(this.cordX, this.cordY);
		LatLong lldest = new LatLong(loc2.cordX, loc2.cordY);
		
		return llsource.distanceToMetres(lldest);
	}

	@Override
	public boolean moveToward(Location destination, double distancePerSecond) throws InfiniteLoopException, LocationMismatch {
		if(!(destination instanceof LocationGeo))
			throw new LocationMismatch();
		
		LocationGeo dst = (LocationGeo) destination;

		if(distancePerSecond <= 0)
			throw new InfiniteLoopException();
		
		if(equals(dst))
			return true;
		
		//How many steps we have toward the destination
		double step = distancePerSecond;
		
		
		LatLong llsource = new LatLong(this.cordX, this.cordY);
		LatLong lldestination = new LatLong(dst.cordX, dst.cordY);
		
		System.err.println("Step: " + step + " The Distance: " + llsource.distanceToMetres(lldestination));
		
		if(step >= llsource.distanceToMetres(lldestination)) {
			llsource = lldestination;
		} else {
			llsource = llsource.travelDistanceMeters(llsource.bearingTo(lldestination), step);
		}
		
		this.cordX = llsource.latitude;
		this.cordY = llsource.longitude;
		
		return equals(dst);
	}

	@Override
	public LocationGeo clone() {
		return new LocationGeo(cordX, cordY);
	}
}
