package edu.swe622.fers.service;

import java.util.ArrayList;
import java.util.ResourceBundle;
import java.util.StringTokenizer;

import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ConfigurationContext;
import org.apache.axis2.description.AxisService;
import org.apache.axis2.engine.ServiceLifeCycle;

import edu.swe622.fers.model.Location;
import edu.swe622.fers.model.LocationXY;


public class SchoolLifeCycle implements ServiceLifeCycle {
	public void shutDown(ConfigurationContext arg0, AxisService arg1) {
		// TODO Auto-generated method stub

	}
	
	/**
	 * Startup populate the required lists on the service startup
	 */
	public void startUp(ConfigurationContext configContext, AxisService service) {
		String serviceName = service.getName();
		try {
			ResourceBundle rb = ResourceBundle.getBundle("schoolconfig");
			ArrayList<String> list = new ArrayList<String>();
			String sprinklers = rb.getString(serviceName+".sprinklers");
			StringTokenizer stk = new StringTokenizer(sprinklers,",");
			while(stk.hasMoreElements()){
				String token = (String)stk.nextElement();
				list.add(token);
			}
			service.addParameter("sprinklerList",list );
			
			list = new ArrayList<String>();
			String detectors = rb.getString(serviceName+".detectors");
			stk = new StringTokenizer(detectors,",");
			while(stk.hasMoreElements()){
				String token = (String)stk.nextElement();
				list.add(token);
			}
			service.addParameter("detectorList",list );
			
			String high =  rb.getString(serviceName+".high");
			service.addParameter("high",high );
			String low =  rb.getString(serviceName+".low");
			service.addParameter("low",low );
			
			Location location = new LocationXY();
			String locationX = rb.getString(serviceName+".location.x");
			String locationY = rb.getString(serviceName+".location.y");
			location.setCordX(Double.parseDouble(locationX));
			location.setCordY(Double.parseDouble(locationY));
			
			service.addParameter("location",location );
			
		} catch (AxisFault e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
