/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package edu.swe622.fers.service;

import java.io.FileInputStream;
import java.io.IOException;
import java.rmi.RemoteException;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.Map;
import java.util.Properties;


import org.apache.axis2.AxisFault;
import org.apache.axis2.context.ServiceContext;
//import gui4.*;

import edu.swe622.fers.model.Location;
import edu.swe622.fers.model.LocationMismatch;
import edu.swe622.fers.model.LocationXY;
import edu.swe622.fers.model.Sensor;
import edu.swe622.fers.model.XYLocation;
import edu.swe622.fers.util.ServiceUtil;

/**
 *
 * @author Zeynep
 */
public class SchoolService {
	
   private ArrayList<String> sprinklerList = new ArrayList<String>();
   private ArrayList<String> detectorList = new ArrayList<String>();
   private boolean isFire = false;
   private Location location;
   private int high;//high strength on working hours
   private int low; //low strength on holidays and non office hours
   
   private HashMap<String, String> uddiMap = new HashMap<String, String>();
   
   public int numofpeople() {
        
        int startHour=9;
        int endHour=15;
        int isweekend=0;
        int issummer=0;
        DateFormat dateFormat = new SimpleDateFormat("MM");
        Date date = new Date();
        int m = Integer.parseInt(dateFormat.format(date));
        DateFormat dateFormat3 = new SimpleDateFormat("HH");
        int h = Integer.parseInt(dateFormat3.format(date));
        int day= Calendar.DAY_OF_WEEK;
        
        if (day==0 || day ==7) // saturday and sundays are weekends
            isweekend=1;
        if (m>=6 && m<=8) //holiday between june to september
            issummer=1;
        
        Properties properties = new Properties();
        
        try {
            properties.load(new FileInputStream("school1.properties"));
        } catch (IOException e) {
        }

        if (startHour<=h && h<endHour && isweekend==0 && issummer==0){
        	System.out.println("HIGH################################");
            return getHigh();
        }else{
        	System.out.println("LOW################################");
            return getLow();
        }
    }  
    
    /**
     * Get the nearest sprinkler by passing the alarmed sensor location 
     * @param location - alarmed smoke detector location.
     * @return a Sprinkler instance
     */
    public Sensor getNearestSprinkler(Location location){
    	//loop though sprinkler 
    	//check the location
    	Sensor returnSprinkler = null;
    	double distance = 10.0;
    	
    	for (String sprinkler : sprinklerList) {
    		
//    		QName serviceQN = new QName(url, sprinkler);
    		try {
				SensorServiceStub stub = new SensorServiceStub(getEndPoint(sprinkler));
				Sensor tempSprinkler = convertToSensor(stub.getSensor().get_return());
				Location tempLocation = tempSprinkler.getLocation();
				Location loc = new Location(tempLocation.getCordX(),tempLocation.getCordY());
				double tempdistance = loc.howFarIs(location);
				if(distance>tempdistance){
					returnSprinkler = tempSprinkler;
					distance = tempdistance;
				}
			} catch (AxisFault e) {
				
				e.printStackTrace();
			} catch (RemoteException e) {
				
				e.printStackTrace();
			} catch (LocationMismatch e) {
				
				e.printStackTrace();
			}
		} 
    	return returnSprinkler;
    }
    /**
     * TODO
     * @param detectorsList
     */
    public void turnOffAllSmokeDetectors(){
    	for (String detector : detectorList) {
    		System.out.println("detector:"+detector);
			try {
				SensorServiceStub stub = new SensorServiceStub(getEndPoint(detector));
				stub.turnOffSensor();
			} catch (AxisFault e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			 catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    	
    }
    public void turnOffAllSprinklers(){
    	System.out.println("Turning off all the Sprinklers");
    	for (String sprinkler : sprinklerList) {
    		
			try {
				SensorServiceStub stub = new SensorServiceStub(getEndPoint(sprinkler));
				stub.turnOffSensor();
			} catch (AxisFault e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			 catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    }
    
    public void turnOnAllSprinklers(){
    	for (String sprinkler : sprinklerList) {
			try {
				SensorServiceStub stub = new SensorServiceStub(getEndPoint(sprinkler));
				if(stub.getSensor().get_return().getStatus()!=1)
					stub.turnOnSensor();
			} catch (AxisFault e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
			 catch (RemoteException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
    	}
    }
	/**
	 * @return the sprinklerMap
	 */
	public ArrayList<String> getSprinklerList() {
		return sprinklerList;
	}
	/**
	 * @param sprinklerMap the sprinklerMap to set
	 */
	public void setSprinklerList(ArrayList<String> sprinklerList) {
		this.sprinklerList = sprinklerList;
	}
	/**
	 * @return the detectorMap
	 */
	public ArrayList<String> getDetectorList() {
		return detectorList;
	}
	/**
	 * @param detectorMap the detectorMap to set
	 */
	public void setDetectorList(ArrayList<String> detectorList) {
		this.detectorList = detectorList;
	}
	/**
	 * @return the isFire
	 */
	public boolean isFire() {
		return isFire;
	}
	/**
	 * @param isFire the isFire to set
	 */
	public void setFire(boolean isFire) {
		this.isFire = isFire;
	}
	
	
	private ServiceContext serviceContext;  
	   
    public void init(ServiceContext serviceContext) {  
        this.serviceContext = serviceContext;  
        sprinklerList = (ArrayList<String>)serviceContext.getAxisService().getParameterValue("sprinklerList");
        detectorList = (ArrayList<String>)serviceContext.getAxisService().getParameterValue("detectorList");
        high = Integer.parseInt((String)serviceContext.getAxisService().getParameterValue("high"));
        low = Integer.parseInt((String)serviceContext.getAxisService().getParameterValue("low"));
        location = (Location)serviceContext.getAxisService().getParameterValue("location");
    }
	/**
	 * @return the location
	 */
	public Location getLocation() {
		return location;
	}
	/**
	 * @param location the location to set
	 */
	public void setLocation(Location location) {
		this.location = location;
	}
	/**
	 * @return the high
	 */
	public int getHigh() {
		return high;
	}
	/**
	 * @param high the high to set
	 */
	public void setHigh(int high) {
		this.high = high;
	}
	/**
	 * @return the low
	 */
	public int getLow() {
		return low;
	}
	/**
	 * @param low the low to set
	 */
	public void setLow(int low) {
		this.low = low;
	}  

	private Location convertToLocation(SensorServiceStub.Location tempLoc){
		Location location = new LocationXY();
		location.setCordX(tempLoc.getCordX());
		location.setCordY(tempLoc.getCordY());
		return location;
	}
	
	private Sensor convertToSensor(SensorServiceStub.Sensor sensor){
		Sensor tempSensor = new Sensor();
		Location tempLocation = new Location();
    	tempLocation.setCordX(sensor.getLocation().getCordX());
    	tempLocation.setCordY(sensor.getLocation().getCordY());
    	tempSensor.setLocation(tempLocation);
    	tempSensor.setNearestFireStation(sensor.getNearestFireStation());
    	tempSensor.setSchoolId(sensor.getSchoolId());
    	tempSensor.setSensorId(sensor.getSensorId());
    	tempSensor.setStatus(sensor.getStatus());
    	tempSensor.setType(sensor.getType());
    	return tempSensor;
	}
	
	private String getEndPoint(String serviceName) {
		
		
		String endPoint = uddiMap.get(serviceName);
		if(endPoint!=null){
			return endPoint;
		}else{
			ServiceUtil.setupProxy("juddi", "juddi");
			Map services =  ServiceUtil.getServiceAccessPoints(serviceName);
			System.out.println("Map: "+services );
			endPoint= (String)services.keySet().iterator().next();
			uddiMap.put(serviceName, endPoint);
			return endPoint;
		}
	}
}
